/* $Id: Byte2Data.java,v 1.1 2007/09/30 07:56:29 mit Exp $ */
/* Byte2Data.java v0.0 */
import javax.sound.sampled.*;

public class Byte2Data {
    public Byte2Data() {}
    public int[] byte2data(byte[] ab, AudioFormat af) {
	int mo = af.getFrameSize();
	int len = ab.length/mo;
	int cnt;
	int msb, lsb, mbb, lbb;
	int[] cd = new int[len];

	if (mo > 2) {
	    if (af.isBigEndian()) {
		for (int i = 0; i < len; i++) {
		    cnt = mo*i;
		    msb = (int)ab[cnt];
		    lsb = (int)ab[cnt+1];
		    mbb = (int)ab[cnt+2];
		    lbb = (int)ab[cnt+3];
		    cd[i] = ((msb << 8 | (255 & lsb))+(mbb << 8 | (255 & lbb)))/2;
		}
	    } else {
		for (int i = 0; i < len; i++) {
		    cnt = mo*i;
		    lsb = (int)ab[cnt];
		    msb = (int)ab[cnt+1];
		    lbb = (int)ab[cnt+2];
		    mbb = (int)ab[cnt+3];
		    cd[i] = ((msb << 8 | (255 & lsb))+(mbb << 8 | (255 & lbb)))/2;
		}
	    }
	} else {
	    if (af.isBigEndian()) {
		for (int i = 0; i < len; i++) {
		    cnt = mo*i;
		    msb = (int)ab[cnt];
		    lsb = (int)ab[cnt+1];
		    cd[i] = msb << 8 | (255 & lsb);
		}
	    } else {
		for (int i = 0; i < len; i++) {
		    cnt = mo*i;
		    lsb = (int)ab[cnt];
		    msb = (int)ab[cnt+1];
		    cd[i] = msb << 8 | (255 & lsb);
		}
	    }
	}
	return cd;
    }
}